package b4a.example;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = true;
	public static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "b4a.example", "b4a.example.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "b4a.example", "b4a.example.main");
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
		return true;
	}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true)
				return true;
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
		this.setIntent(intent);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public static anywheresoftware.b4a.sql.SQL _sql1 = null;
public static anywheresoftware.b4a.sql.SQL.CursorWrapper _cursor1 = null;
public static String _query = "";
public anywheresoftware.b4a.phone.Phone.PhoneSms _sms = null;
public static String _number = "";
public anywheresoftware.b4a.objects.ListViewWrapper _lvdb = null;
public anywheresoftware.b4a.objects.EditTextWrapper _txtname = null;
public anywheresoftware.b4a.objects.EditTextWrapper _txtnumber = null;
public static String _id = "";
public anywheresoftware.b4a.objects.EditTextWrapper _txtmessage = null;
public static String  _activity_create(boolean _firsttime) throws Exception{
		Debug.PushSubsStack("Activity_Create (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("FirstTime", _firsttime);
 BA.debugLineNum = 35;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
Debug.ShouldStop(4);
 BA.debugLineNum = 37;BA.debugLine="Activity.LoadLayout(\"sms_layout\")";
Debug.ShouldStop(16);
mostCurrent._activity.LoadLayout("sms_layout",mostCurrent.activityBA);
 BA.debugLineNum = 39;BA.debugLine="End Sub";
Debug.ShouldStop(64);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _activity_pause(boolean _userclosed) throws Exception{
		Debug.PushSubsStack("Activity_Pause (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("UserClosed", _userclosed);
 BA.debugLineNum = 49;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
Debug.ShouldStop(65536);
 BA.debugLineNum = 51;BA.debugLine="End Sub";
Debug.ShouldStop(262144);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _activity_resume() throws Exception{
		Debug.PushSubsStack("Activity_Resume (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
 BA.debugLineNum = 45;BA.debugLine="Sub Activity_Resume";
Debug.ShouldStop(4096);
 BA.debugLineNum = 47;BA.debugLine="End Sub";
Debug.ShouldStop(16384);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _cmdadd_click() throws Exception{
		Debug.PushSubsStack("cmdAdd_Click (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
int _i = 0;
int _newid = 0;
 BA.debugLineNum = 75;BA.debugLine="Sub cmdAdd_Click";
Debug.ShouldStop(1024);
 BA.debugLineNum = 76;BA.debugLine="If txtName.Text = \"\" OR txtNumber.Text=\"\" Then";
Debug.ShouldStop(2048);
if ((mostCurrent._txtname.getText()).equals("") || (mostCurrent._txtnumber.getText()).equals("")) { 
 BA.debugLineNum = 77;BA.debugLine="Msgbox(\"You have to enter all fields\",\"Missed data field\")";
Debug.ShouldStop(4096);
anywheresoftware.b4a.keywords.Common.Msgbox("You have to enter all fields","Missed data field",mostCurrent.activityBA);
 }else {
 BA.debugLineNum = 81;BA.debugLine="cursor1 = SQL1.ExecQuery(\"SELECT ID FROM tblcontacts\")";
Debug.ShouldStop(65536);
_cursor1.setObject((android.database.Cursor)(_sql1.ExecQuery("SELECT ID FROM tblcontacts")));
 BA.debugLineNum = 82;BA.debugLine="If cursor1.RowCount > 0 Then";
Debug.ShouldStop(131072);
if (_cursor1.getRowCount()>0) { 
 BA.debugLineNum = 83;BA.debugLine="For i = 0 To cursor1.RowCount - 1";
Debug.ShouldStop(262144);
{
final double step50 = 1;
final double limit50 = (int)(_cursor1.getRowCount()-1);
for (_i = (int)(0); (step50 > 0 && _i <= limit50) || (step50 < 0 && _i >= limit50); _i += step50) {
Debug.locals.put("i", _i);
 BA.debugLineNum = 84;BA.debugLine="cursor1.Position = i";
Debug.ShouldStop(524288);
_cursor1.setPosition(_i);
 BA.debugLineNum = 86;BA.debugLine="Dim NewID As Int";
Debug.ShouldStop(2097152);
_newid = 0;Debug.locals.put("NewID", _newid);
 BA.debugLineNum = 87;BA.debugLine="NewID = cursor1.GetInt(\"ID\")";
Debug.ShouldStop(4194304);
_newid = _cursor1.GetInt("ID");Debug.locals.put("NewID", _newid);
 }
}Debug.locals.put("i", _i);
;
 };
 BA.debugLineNum = 91;BA.debugLine="NewID = NewID +1 ' add 1 to the ID number to make a new ID field";
Debug.ShouldStop(67108864);
_newid = (int)(_newid+1);Debug.locals.put("NewID", _newid);
 BA.debugLineNum = 92;BA.debugLine="SQL1.ExecNonQuery(\"INSERT INTO tblcontacts VALUES('\" & NewID & \"','\" & txtName.Text & \"','\" & txtNumber.Text & \"')\")";
Debug.ShouldStop(134217728);
_sql1.ExecNonQuery("INSERT INTO tblcontacts VALUES('"+BA.NumberToString(_newid)+"','"+mostCurrent._txtname.getText()+"','"+mostCurrent._txtnumber.getText()+"')");
 BA.debugLineNum = 93;BA.debugLine="DBload";
Debug.ShouldStop(268435456);
_dbload();
 BA.debugLineNum = 95;BA.debugLine="txtName.Text = \"\"";
Debug.ShouldStop(1073741824);
mostCurrent._txtname.setText((Object)(""));
 BA.debugLineNum = 96;BA.debugLine="txtNumber.Text = \"\"";
Debug.ShouldStop(-2147483648);
mostCurrent._txtnumber.setText((Object)(""));
 BA.debugLineNum = 97;BA.debugLine="txtName.RequestFocus";
Debug.ShouldStop(1);
mostCurrent._txtname.RequestFocus();
 };
 BA.debugLineNum = 101;BA.debugLine="End Sub";
Debug.ShouldStop(16);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _cmdcontacts_click() throws Exception{
		Debug.PushSubsStack("cmdContacts_Click (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
 BA.debugLineNum = 40;BA.debugLine="Sub cmdContacts_Click";
Debug.ShouldStop(128);
 BA.debugLineNum = 41;BA.debugLine="RemoveView";
Debug.ShouldStop(256);
_removeview();
 BA.debugLineNum = 42;BA.debugLine="Activity.LoadLayout(\"contacts\")";
Debug.ShouldStop(512);
mostCurrent._activity.LoadLayout("contacts",mostCurrent.activityBA);
 BA.debugLineNum = 43;BA.debugLine="DBload";
Debug.ShouldStop(1024);
_dbload();
 BA.debugLineNum = 44;BA.debugLine="End Sub";
Debug.ShouldStop(2048);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _cmddelete_click() throws Exception{
		Debug.PushSubsStack("cmdDelete_Click (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
 BA.debugLineNum = 102;BA.debugLine="Sub cmdDelete_Click";
Debug.ShouldStop(32);
 BA.debugLineNum = 104;BA.debugLine="If txtName.Text = \"\" OR txtNumber.Text = \"\"  Then";
Debug.ShouldStop(128);
if ((mostCurrent._txtname.getText()).equals("") || (mostCurrent._txtnumber.getText()).equals("")) { 
 BA.debugLineNum = 105;BA.debugLine="Msgbox(\"Select item to delete\",\"Missed data item\")";
Debug.ShouldStop(256);
anywheresoftware.b4a.keywords.Common.Msgbox("Select item to delete","Missed data item",mostCurrent.activityBA);
 }else {
 BA.debugLineNum = 107;BA.debugLine="SQL1.ExecNonQuery(\"DELETE FROM tblcontacts where ID = '\" &ID & \"' \")";
Debug.ShouldStop(1024);
_sql1.ExecNonQuery("DELETE FROM tblcontacts where ID = '"+mostCurrent._id+"' ");
 };
 BA.debugLineNum = 110;BA.debugLine="DBload";
Debug.ShouldStop(8192);
_dbload();
 BA.debugLineNum = 111;BA.debugLine="txtName.Text = \"\"";
Debug.ShouldStop(16384);
mostCurrent._txtname.setText((Object)(""));
 BA.debugLineNum = 112;BA.debugLine="txtNumber.Text = \"\"";
Debug.ShouldStop(32768);
mostCurrent._txtnumber.setText((Object)(""));
 BA.debugLineNum = 113;BA.debugLine="txtName.RequestFocus";
Debug.ShouldStop(65536);
mostCurrent._txtname.RequestFocus();
 BA.debugLineNum = 114;BA.debugLine="End Sub";
Debug.ShouldStop(131072);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _cmdexit_click() throws Exception{
		Debug.PushSubsStack("cmdExit_Click (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
 BA.debugLineNum = 142;BA.debugLine="Sub cmdExit_Click";
Debug.ShouldStop(8192);
 BA.debugLineNum = 143;BA.debugLine="Activity.Finish";
Debug.ShouldStop(16384);
mostCurrent._activity.Finish();
 BA.debugLineNum = 144;BA.debugLine="End Sub";
Debug.ShouldStop(32768);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _cmdsearch_click() throws Exception{
		Debug.PushSubsStack("cmdSearch_Click (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
 BA.debugLineNum = 145;BA.debugLine="Sub cmdSearch_Click";
Debug.ShouldStop(65536);
 BA.debugLineNum = 150;BA.debugLine="Query =(\"SELECT * FROM tblcontacts WHERE name='\"& txtName.text &\"'\" )";
Debug.ShouldStop(2097152);
_query = ("SELECT * FROM tblcontacts WHERE name='"+mostCurrent._txtname.getText()+"'");
 BA.debugLineNum = 152;BA.debugLine="cursor1 = SQL1.ExecQuery(Query)";
Debug.ShouldStop(8388608);
_cursor1.setObject((android.database.Cursor)(_sql1.ExecQuery(_query)));
 BA.debugLineNum = 155;BA.debugLine="If cursor1.RowCount > 0 Then";
Debug.ShouldStop(67108864);
if (_cursor1.getRowCount()>0) { 
 BA.debugLineNum = 156;BA.debugLine="Msgbox(\"Record Found!\", \"\")";
Debug.ShouldStop(134217728);
anywheresoftware.b4a.keywords.Common.Msgbox("Record Found!","",mostCurrent.activityBA);
 BA.debugLineNum = 157;BA.debugLine="If cursor1.RowCount = 1 Then";
Debug.ShouldStop(268435456);
if (_cursor1.getRowCount()==1) { 
 BA.debugLineNum = 158;BA.debugLine="cursor1.Position = 0";
Debug.ShouldStop(536870912);
_cursor1.setPosition((int)(0));
 BA.debugLineNum = 159;BA.debugLine="txtName.Text=cursor1.GetString(\"Name\")";
Debug.ShouldStop(1073741824);
mostCurrent._txtname.setText((Object)(_cursor1.GetString("Name")));
 BA.debugLineNum = 160;BA.debugLine="txtNumber.Text=cursor1.GetString(\"Contact_No\")";
Debug.ShouldStop(-2147483648);
mostCurrent._txtnumber.setText((Object)(_cursor1.GetString("Contact_No")));
 };
 }else {
 BA.debugLineNum = 167;BA.debugLine="Msgbox(\"NO Record Found!\", \"\")";
Debug.ShouldStop(64);
anywheresoftware.b4a.keywords.Common.Msgbox("NO Record Found!","",mostCurrent.activityBA);
 };
 BA.debugLineNum = 172;BA.debugLine="End Sub";
Debug.ShouldStop(2048);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _cmdsend_click() throws Exception{
		Debug.PushSubsStack("cmdSend_Click (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
int _i = 0;
 BA.debugLineNum = 179;BA.debugLine="Sub cmdSend_Click";
Debug.ShouldStop(262144);
 BA.debugLineNum = 181;BA.debugLine="If File.Exists(File.DirInternal,\"dbt.sql\") = False Then";
Debug.ShouldStop(1048576);
if (anywheresoftware.b4a.keywords.Common.File.Exists(anywheresoftware.b4a.keywords.Common.File.getDirInternal(),"dbt.sql")==anywheresoftware.b4a.keywords.Common.False) { 
 BA.debugLineNum = 182;BA.debugLine="File.Copy(File.DirAssets,\"dbt.sql\",File.DirInternal,\"dbt.sql\")";
Debug.ShouldStop(2097152);
anywheresoftware.b4a.keywords.Common.File.Copy(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),"dbt.sql",anywheresoftware.b4a.keywords.Common.File.getDirInternal(),"dbt.sql");
 };
 BA.debugLineNum = 185;BA.debugLine="If SQL1.IsInitialized = False Then";
Debug.ShouldStop(16777216);
if (_sql1.IsInitialized()==anywheresoftware.b4a.keywords.Common.False) { 
 BA.debugLineNum = 186;BA.debugLine="SQL1.Initialize(File.DirInternal, \"dbt.sql\", False)";
Debug.ShouldStop(33554432);
Debug.DebugWarningEngine.CheckInitialize(_sql1);_sql1.Initialize(anywheresoftware.b4a.keywords.Common.File.getDirInternal(),"dbt.sql",anywheresoftware.b4a.keywords.Common.False);
 };
 BA.debugLineNum = 189;BA.debugLine="cursor1 = SQL1.ExecQuery(\"SELECT Contact_No FROM tblcontacts\")";
Debug.ShouldStop(268435456);
_cursor1.setObject((android.database.Cursor)(_sql1.ExecQuery("SELECT Contact_No FROM tblcontacts")));
 BA.debugLineNum = 191;BA.debugLine="For i = 0 To cursor1.RowCount - 1";
Debug.ShouldStop(1073741824);
{
final double step130 = 1;
final double limit130 = (int)(_cursor1.getRowCount()-1);
for (_i = (int)(0); (step130 > 0 && _i <= limit130) || (step130 < 0 && _i >= limit130); _i += step130) {
Debug.locals.put("i", _i);
 BA.debugLineNum = 192;BA.debugLine="cursor1.Position = i";
Debug.ShouldStop(-2147483648);
_cursor1.setPosition(_i);
 BA.debugLineNum = 194;BA.debugLine="number = cursor1.GetString(\"Contact_No\")";
Debug.ShouldStop(2);
mostCurrent._number = _cursor1.GetString("Contact_No");
 BA.debugLineNum = 197;BA.debugLine="Sms.Send(number,txtMessage.Text)";
Debug.ShouldStop(16);
mostCurrent._sms.Send(mostCurrent._number,mostCurrent._txtmessage.getText());
 }
}Debug.locals.put("i", _i);
;
 BA.debugLineNum = 200;BA.debugLine="Msgbox(\"Message sent..\",\"Confirmation Message\")";
Debug.ShouldStop(128);
anywheresoftware.b4a.keywords.Common.Msgbox("Message sent..","Confirmation Message",mostCurrent.activityBA);
 BA.debugLineNum = 201;BA.debugLine="txtMessage.Text=\"\"";
Debug.ShouldStop(256);
mostCurrent._txtmessage.setText((Object)(""));
 BA.debugLineNum = 202;BA.debugLine="txtMessage.RequestFocus";
Debug.ShouldStop(512);
mostCurrent._txtmessage.RequestFocus();
 BA.debugLineNum = 204;BA.debugLine="End Sub";
Debug.ShouldStop(2048);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _cmdupdate_click() throws Exception{
		Debug.PushSubsStack("cmdUpdate_Click (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
 BA.debugLineNum = 115;BA.debugLine="Sub cmdUpdate_Click";
Debug.ShouldStop(262144);
 BA.debugLineNum = 116;BA.debugLine="If txtName.Text = \"\" OR txtNumber.Text = \"\"  Then";
Debug.ShouldStop(524288);
if ((mostCurrent._txtname.getText()).equals("") || (mostCurrent._txtnumber.getText()).equals("")) { 
 BA.debugLineNum = 117;BA.debugLine="Msgbox(\"Select item to edit\",\"Missed data item\")";
Debug.ShouldStop(1048576);
anywheresoftware.b4a.keywords.Common.Msgbox("Select item to edit","Missed data item",mostCurrent.activityBA);
 }else {
 BA.debugLineNum = 119;BA.debugLine="SQL1.ExecNonQuery(\"UPDATE tblcontacts set Name='\"& txtName.text &\"',Contact_No ='\"& txtNumber.text & \"' WHERE ID = \" & ID)";
Debug.ShouldStop(4194304);
_sql1.ExecNonQuery("UPDATE tblcontacts set Name='"+mostCurrent._txtname.getText()+"',Contact_No ='"+mostCurrent._txtnumber.getText()+"' WHERE ID = "+mostCurrent._id);
 BA.debugLineNum = 120;BA.debugLine="DBload";
Debug.ShouldStop(8388608);
_dbload();
 };
 BA.debugLineNum = 122;BA.debugLine="txtName.Text = \"\"";
Debug.ShouldStop(33554432);
mostCurrent._txtname.setText((Object)(""));
 BA.debugLineNum = 123;BA.debugLine="txtNumber.Text = \"\"";
Debug.ShouldStop(67108864);
mostCurrent._txtnumber.setText((Object)(""));
 BA.debugLineNum = 124;BA.debugLine="txtName.RequestFocus";
Debug.ShouldStop(134217728);
mostCurrent._txtname.RequestFocus();
 BA.debugLineNum = 125;BA.debugLine="End Sub";
Debug.ShouldStop(268435456);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _dbload() throws Exception{
		Debug.PushSubsStack("DBload (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
int _i = 0;
 BA.debugLineNum = 53;BA.debugLine="Sub DBload";
Debug.ShouldStop(1048576);
 BA.debugLineNum = 54;BA.debugLine="If File.Exists(File.DirInternal,\"dbt.sql\") = False Then";
Debug.ShouldStop(2097152);
if (anywheresoftware.b4a.keywords.Common.File.Exists(anywheresoftware.b4a.keywords.Common.File.getDirInternal(),"dbt.sql")==anywheresoftware.b4a.keywords.Common.False) { 
 BA.debugLineNum = 55;BA.debugLine="File.Copy(File.DirAssets,\"dbt.sql\",File.DirInternal,\"dbt.sql\")";
Debug.ShouldStop(4194304);
anywheresoftware.b4a.keywords.Common.File.Copy(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),"dbt.sql",anywheresoftware.b4a.keywords.Common.File.getDirInternal(),"dbt.sql");
 };
 BA.debugLineNum = 58;BA.debugLine="If SQL1.IsInitialized = False Then";
Debug.ShouldStop(33554432);
if (_sql1.IsInitialized()==anywheresoftware.b4a.keywords.Common.False) { 
 BA.debugLineNum = 59;BA.debugLine="SQL1.Initialize(File.DirInternal, \"dbt.sql\", False)";
Debug.ShouldStop(67108864);
Debug.DebugWarningEngine.CheckInitialize(_sql1);_sql1.Initialize(anywheresoftware.b4a.keywords.Common.File.getDirInternal(),"dbt.sql",anywheresoftware.b4a.keywords.Common.False);
 };
 BA.debugLineNum = 61;BA.debugLine="LVDb.Clear'need to clear the list";
Debug.ShouldStop(268435456);
mostCurrent._lvdb.Clear();
 BA.debugLineNum = 62;BA.debugLine="cursor1 = SQL1.ExecQuery(\"SELECT * FROM tblcontacts\")";
Debug.ShouldStop(536870912);
_cursor1.setObject((android.database.Cursor)(_sql1.ExecQuery("SELECT * FROM tblcontacts")));
 BA.debugLineNum = 64;BA.debugLine="For i = 0 To cursor1.RowCount - 1";
Debug.ShouldStop(-2147483648);
{
final double step35 = 1;
final double limit35 = (int)(_cursor1.getRowCount()-1);
for (_i = (int)(0); (step35 > 0 && _i <= limit35) || (step35 < 0 && _i >= limit35); _i += step35) {
Debug.locals.put("i", _i);
 BA.debugLineNum = 65;BA.debugLine="cursor1.Position = i";
Debug.ShouldStop(1);
_cursor1.setPosition(_i);
 BA.debugLineNum = 66;BA.debugLine="LVDb.AddSingleLine(cursor1.GetString(\"ID\")& \"|\" &cursor1.GetString(\"Name\")& \" | \" & cursor1.GetString(\"Contact_No\"))";
Debug.ShouldStop(2);
mostCurrent._lvdb.AddSingleLine(_cursor1.GetString("ID")+"|"+_cursor1.GetString("Name")+" | "+_cursor1.GetString("Contact_No"));
 BA.debugLineNum = 67;BA.debugLine="LVDb.SingleLineLayout.ItemHeight = 40";
Debug.ShouldStop(4);
mostCurrent._lvdb.getSingleLineLayout().setItemHeight((int)(40));
 BA.debugLineNum = 68;BA.debugLine="LVDb.SingleLineLayout.Label.TextSize = 20";
Debug.ShouldStop(8);
mostCurrent._lvdb.getSingleLineLayout().Label.setTextSize((float)(20));
 BA.debugLineNum = 69;BA.debugLine="LVDb.SingleLineLayout.Label.TextColor = Colors.Black";
Debug.ShouldStop(16);
mostCurrent._lvdb.getSingleLineLayout().Label.setTextColor(anywheresoftware.b4a.keywords.Common.Colors.Black);
 BA.debugLineNum = 70;BA.debugLine="LVDb.SingleLineLayout.Label.Color = Colors.White";
Debug.ShouldStop(32);
mostCurrent._lvdb.getSingleLineLayout().Label.setColor(anywheresoftware.b4a.keywords.Common.Colors.White);
 }
}Debug.locals.put("i", _i);
;
 BA.debugLineNum = 73;BA.debugLine="End Sub";
Debug.ShouldStop(256);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}

public static void initializeProcessGlobals() {
    if (mostCurrent != null && mostCurrent.activityBA != null) {
Debug.StartDebugging(mostCurrent.activityBA, 40488, new int[] {7}, "525af1d4-1227-4e7a-8ab3-af6705eab254");}

    if (processGlobalsRun == false) {
	    processGlobalsRun = true;
		try {
		        main._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}

public static void killProgram() {
    
            if (main.previousOne != null) {
				Activity a = main.previousOne.get();
				if (a != null)
					a.finish();
			}

}
public static String  _globals() throws Exception{
 //BA.debugLineNum = 22;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 25;BA.debugLine="Dim Sms As PhoneSms";
mostCurrent._sms = new anywheresoftware.b4a.phone.Phone.PhoneSms();
 //BA.debugLineNum = 26;BA.debugLine="Dim number As String";
mostCurrent._number = "";
 //BA.debugLineNum = 28;BA.debugLine="Dim LVDb As ListView";
mostCurrent._lvdb = new anywheresoftware.b4a.objects.ListViewWrapper();
 //BA.debugLineNum = 29;BA.debugLine="Dim txtName As EditText";
mostCurrent._txtname = new anywheresoftware.b4a.objects.EditTextWrapper();
 //BA.debugLineNum = 30;BA.debugLine="Dim txtNumber As EditText";
mostCurrent._txtnumber = new anywheresoftware.b4a.objects.EditTextWrapper();
 //BA.debugLineNum = 31;BA.debugLine="Dim ID As String";
mostCurrent._id = "";
 //BA.debugLineNum = 32;BA.debugLine="Dim txtMessage As EditText";
mostCurrent._txtmessage = new anywheresoftware.b4a.objects.EditTextWrapper();
 //BA.debugLineNum = 33;BA.debugLine="End Sub";
return "";
}
public static String  _lvdb_itemclick(int _position,Object _value) throws Exception{
		Debug.PushSubsStack("LVDb_ItemClick (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
String _idvalue = "";
int _countit = 0;
int _i = 0;
Debug.locals.put("Position", _position);
Debug.locals.put("Value", _value);
 BA.debugLineNum = 127;BA.debugLine="Sub LVDb_ItemClick (Position As Int, Value As Object)' click on the entry in the list";
Debug.ShouldStop(1073741824);
 BA.debugLineNum = 128;BA.debugLine="Dim idvalue As String";
Debug.ShouldStop(-2147483648);
_idvalue = "";Debug.locals.put("idvalue", _idvalue);
 BA.debugLineNum = 129;BA.debugLine="Dim countIt As Int";
Debug.ShouldStop(1);
_countit = 0;Debug.locals.put("countIt", _countit);
 BA.debugLineNum = 131;BA.debugLine="idvalue = Value";
Debug.ShouldStop(4);
_idvalue = String.valueOf(_value);Debug.locals.put("idvalue", _idvalue);
 BA.debugLineNum = 132;BA.debugLine="countIt = idvalue.IndexOf(\"|\") 'find location of sperator";
Debug.ShouldStop(8);
_countit = _idvalue.indexOf("|");Debug.locals.put("countIt", _countit);
 BA.debugLineNum = 133;BA.debugLine="idvalue = idvalue.SubString2(0,countIt) 'find first part of label text";
Debug.ShouldStop(16);
_idvalue = _idvalue.substring((int)(0),_countit);Debug.locals.put("idvalue", _idvalue);
 BA.debugLineNum = 134;BA.debugLine="ID = idvalue";
Debug.ShouldStop(32);
mostCurrent._id = _idvalue;
 BA.debugLineNum = 136;BA.debugLine="For i = 0 To cursor1.RowCount - 1";
Debug.ShouldStop(128);
{
final double step93 = 1;
final double limit93 = (int)(_cursor1.getRowCount()-1);
for (_i = (int)(0); (step93 > 0 && _i <= limit93) || (step93 < 0 && _i >= limit93); _i += step93) {
Debug.locals.put("i", _i);
 BA.debugLineNum = 137;BA.debugLine="cursor1.Position = i";
Debug.ShouldStop(256);
_cursor1.setPosition(_i);
 BA.debugLineNum = 138;BA.debugLine="txtName.text=cursor1.getString(\"Name\")";
Debug.ShouldStop(512);
mostCurrent._txtname.setText((Object)(_cursor1.GetString("Name")));
 BA.debugLineNum = 139;BA.debugLine="txtNumber.text=cursor1.getString(\"Contact_No\")";
Debug.ShouldStop(1024);
mostCurrent._txtnumber.setText((Object)(_cursor1.GetString("Contact_No")));
 }
}Debug.locals.put("i", _i);
;
 BA.debugLineNum = 141;BA.debugLine="End Sub";
Debug.ShouldStop(4096);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 15;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 16;BA.debugLine="Dim SQL1 As SQL";
_sql1 = new anywheresoftware.b4a.sql.SQL();
 //BA.debugLineNum = 17;BA.debugLine="Dim cursor1 As Cursor";
_cursor1 = new anywheresoftware.b4a.sql.SQL.CursorWrapper();
 //BA.debugLineNum = 18;BA.debugLine="Dim Query As String";
_query = "";
 //BA.debugLineNum = 20;BA.debugLine="End Sub";
return "";
}
public static String  _removeview() throws Exception{
		Debug.PushSubsStack("RemoveView (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
int _i = 0;
 BA.debugLineNum = 173;BA.debugLine="Sub RemoveView";
Debug.ShouldStop(4096);
 BA.debugLineNum = 174;BA.debugLine="Dim i As Int";
Debug.ShouldStop(8192);
_i = 0;Debug.locals.put("i", _i);
 BA.debugLineNum = 175;BA.debugLine="For i = Activity.NumberOfViews-1 To 0 Step-1";
Debug.ShouldStop(16384);
{
final double step118 = -1;
final double limit118 = (int)(0);
for (_i = (int)(mostCurrent._activity.getNumberOfViews()-1); (step118 > 0 && _i <= limit118) || (step118 < 0 && _i >= limit118); _i += step118) {
Debug.locals.put("i", _i);
 BA.debugLineNum = 176;BA.debugLine="Activity.RemoveViewAt (i)";
Debug.ShouldStop(32768);
mostCurrent._activity.RemoveViewAt(_i);
 }
}Debug.locals.put("i", _i);
;
 BA.debugLineNum = 178;BA.debugLine="End Sub";
Debug.ShouldStop(131072);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
  public Object[] GetGlobals() {
		return new Object[] {"Activity",_activity,"SQL1",_sql1,"cursor1",_cursor1,"Query",_query,"Sms",_sms,"number",_number,"LVDb",_lvdb,"txtName",_txtname,"txtNumber",_txtnumber,"ID",_id,"txtMessage",_txtmessage};
}
}
